/** @(#) listpos/allstackqueuepos.h */
/**
* NOTA: Para un mejor mantenimiento se opto por tener todas las clases juntas.
* No se tiene archivo allstackqueuepos.cpp porque el cuerpo de los
* constructores es de una linea.
*/
#ifndef ALLSTACKQUEUEPOS_H
#define ALLSTACKQUEUEPOS_H
/**
* NOTA: Para un mejor mantenimiento se opto por tener todas las clases juntas.
* No se tiene archivo allstackqueuepos.cpp porque el cuerpo de los
* constructores es de una linea.
*/
//----------------------------------------------------------------------------
#include "listpos/listexceptionpos.h"

// { error si *.h por template, solo cpp. dificil
#include "listpos/queuepos.cpp"
#include "listpos/stackpos.cpp"

#include "listpos/fixedlistpos.cpp"
#include "listpos/cpplistpos.cpp"
#include "listpos/dynamiclistpos.cpp"
#include "listpos/listnodepos.cpp"
// } error si *.h por template. dificil

#include <iostream>
#include <string>
#include <stdexcept>	// runtime_exception
using namespace std;

/**
* Construye una cola que puede crecer basada en una lista dinamica.
* @author Omar Posada Villarreal
* @version 2.0, 10/12/2001 C++
*/
template <class TObj>
class  DynamicQueuePos : public QueuePos<TObj> {
public:
	/**
	* Construye una cola que puede crecer basada en una lista dinamica.
	*/
	DynamicQueuePos() : QueuePos<TObj> ( new DynamicListPos<TObj>() ) {
        }
	// Destructor predeterminado
};
//----------------------------------------------------------------------------
/**
* Construye una pila que puede crecer basada en una lista dinamica.
* @author Omar Posada Villarreal
* @version 2.0, 10/12/2001 C++
*/
template <class TObj>
class DynamicStackPos : public StackPos<TObj> {
public:
	/**
	* Construye una pila que puede crecer basada en una lista dinamica.
	*/
	DynamicStackPos() : StackPos<TObj> ( new DynamicListPos<TObj>() ) {
        }
	// Destructor predeterminado
};
//----------------------------------------------------------------------------
/**
* Construye una cola estatica basada en una lista estatica.
* @author Omar Posada Villarreal
* @version 2.0, 10/12/2001 C++
*/
template <class TObj>
class FixedQueuePos : public QueuePos<TObj> {
public:
	/**
	* Construye una pila estatica basada en una lista estatica.
	* @param itemCount Numero fijo de elementos.
	*/
	FixedQueuePos(int itemCount)
        	: QueuePos<TObj>( new FixedListPos<TObj>(itemCount)) {
        }
	/** Construye una pila estatica basada en una lista estatica. */
	FixedQueuePos()
        	: QueuePos<TObj>( new FixedListPos<TObj>()) {
        }
	// Destructor predeterminado
};
//----------------------------------------------------------------------------
/**
* Construye una pila estatica basada en una lista estatica.
* @author Omar Posada Villarreal
* @version 2.0, 10/12/2001 C++
*/
template <class TObj>
class FixedStackPos : public StackPos<TObj> {
public:
	/**
	* Construye una pila estatica basada en una lista estatica.
	* @param itemCount Numero fijo de elementos.
	*/
	FixedStackPos(int itemCount)
        	: StackPos<TObj>( new FixedListPos<TObj>(itemCount)) {
        }
	/** Construye una pila estatica basada en una lista estatica. */
	FixedStackPos()
        	: StackPos<TObj>( new FixedListPos<TObj>()) {
        }
	// Destructor predeterminado
};
//----------------------------------------------------------------------------
/**
* Construye una cola dinamica basada en un "Vector" (libreria de C++).
* @author Omar Posada Villarreal
* @version 2.0, 10/12/2001 C++
*/
template <class TObj>
class CppQueuePos : public QueuePos<TObj> {
public:
	/**
	* Construye una cola dinamica basada en un "Vector" (libreria de C++).
	*/
	CppQueuePos() : QueuePos<TObj>( new CppListPos<TObj>() ) {
        }
	// Destructor predeterminado
};
//----------------------------------------------------------------------------
/**
* Construye una pila dinamica basada en un "Vector" (libreria de C++).
* @author Omar Posada Villarreal
* @version 2.0, 10/12/2001 C++
*/
template <class TObj>
class CppStackPos : public StackPos<TObj> {
public:
	/**
	* Construye una pila dinamica basada en un "Vector" (libreria de C++).
	*/
	CppStackPos() : StackPos<TObj>( new CppListPos<TObj>() ) {
        }
	// Destructor predeterminado
};
//----------------------------------------------------------------------------
#endif
// Fin------------------------------------------------------------------------
