/* @(#) listpos/dlinklistpos.h */
/**
* Implementa la lista doblemente ligada con almacenamiento dinamico.
* @author Omar Posada Villarreal
* @version 2.0, 02/01/2002 C++
* @version 1.0, 26/10/2001
*/
#ifndef DLINKLISTPOS_H
#define DLINKLISTPOS_H
//----------------------------------------------------------------------------
#include "listexceptionpos.h"
#include "listpos.h"	// padre
#include "dlinknodepos.h"

/**
* Implementa la lista doblemente ligada con almacenamiento dinamico. 
* @author Omar Posada Villarreal
* @version 2.0, 02/01/2002 C++
* @version 1.0, 26/10/2001
*/
template <class TObj>
class DLinkListPos : public ListPos<TObj> {	// public muestra miembro
	friend ostream &operator<<<TObj>(ostream &outStr,
	      	const DLinkListPos<TObj> &list);

public:
	DLinkListPos();	// Constructor sin elementos
	~DLinkListPos();	// Destructor. Libera memoria.

/*	ostream &operator<<(ostream &outStr,
	      	const DLinkListPos<TObj> &list);
*/
	int size() const;
	bool isEmpty() const;
	bool isFull() const;
	void print() const;

	void addFirst(const TObj item) throw (FullListExceptionPos);
	void addLast(const TObj item) throw (FullListExceptionPos);
	TObj removeFirst() throw(EmptyListExceptionPos);
	TObj removeLast() throw(EmptyListExceptionPos);
	void removeAllElements();

	TObj getLast() throw(EmptyListExceptionPos);

//Solo de DLinkListPos---------------------------------------------------------
	TObj getFirst() const throw(EmptyListExceptionPos);
 	DLinkNodePos<TObj> * getFirstNode() const throw(EmptyListExceptionPos);
/* usar protected en first y last
*	DLinkNodePos<TObj> * getLastNode() const throw(EmptyListExceptionPos);
*	void setFirstNode(DLinkNodePos<TObj> * node);
*	void setLastNode(DLinkNodePos<TObj> * node);
*/
	DLinkNodePos<TObj> * getLeftNode(const DLinkNodePos<TObj> * node)
        	const throw(EmptyListExceptionPos);
	DLinkNodePos<TObj> * getRightNode(const DLinkNodePos<TObj> * node)
        	const throw(EmptyListExceptionPos);

	DLinkNodePos<TObj> * find(const TObj item) const;
	TObj get(const DLinkNodePos<TObj> * node)
        	const throw(EmptyListExceptionPos);
	TObj remove(DLinkNodePos<TObj> * node)
        	throw(EmptyListExceptionPos);

protected:
	/** Numero de nodos. */
	int	itemCount;

	/** Primer nodo de la lista. Si es igual a null, esta vacia. */
	DLinkNodePos<TObj>	*first;

	/** Ultimo nodo de la lista. Si es igual a null, esta vacia. */
	DLinkNodePos<TObj>	*last;
};
//----------------------------------------------------------------------------
#endif
// Fin------------------------------------------------------------------------

