/** @(#) listpos/dynamiclistpos.h */
/**
* Implementa la lista con almacenamiento dinamico.
* @author Omar Posada Villarreal
* @version 1.2, 10/12/2001 C++
* @version 1.1, 15/10/2001 getFirst(), getNext()
* @version 1.0, 03/10/2001
*/
#ifndef DYNAMICLISTPOS_H
#define DYNAMICLISTPOS_H
//----------------------------------------------------------------------------
#include "listexceptionpos.h"
#include "listpos.h"	// padre
#include "listnodepos.h"

/**
* Implementa la lista con almacenamiento dinamico.
* @author Omar Posada Villarreal
* @version 1.2, 10/12/2001 C++
* @version 1.1, 15/10/2001 getFirst(), getNext()
* @version 1.0, 03/10/2001
*/
template <class TObj>
class DynamicListPos : public ListPos<TObj> {	// public muestra miembros
//error	friend ostream& operator<<(
//         	ostream &outStr, const DynamicListPos<TObj> &list); // ???const <TObj>
public:
	DynamicListPos();	// Constructor sin elementos
	~DynamicListPos();	// Destructor. Libera memoria.

        int size() const;
	bool isEmpty() const;
	bool isFull() const;
	void print() const;

        void addFirst(const TObj item) throw (FullListExceptionPos);
	void addLast(const TObj item) throw (FullListExceptionPos);
	TObj removeFirst() throw(EmptyListExceptionPos);
	TObj removeLast() throw(EmptyListExceptionPos);
	void removeAllElements();

        TObj getLast() throw(EmptyListExceptionPos);
	TObj getFirst() throw(EmptyListExceptionPos);
	ListNodePos<TObj> * getFirstNode() throw(EmptyListExceptionPos);
	ListNodePos<TObj> * getNextNode(const ListNodePos<TObj> * node)
        	throw(EmptyListExceptionPos);
	TObj get(const ListNodePos<TObj> * node) throw(EmptyListExceptionPos);

private:
	/** Primer nodo de la lista. Si es igual a null, esta vacia. */
	ListNodePos<TObj>	*first;

	/** Ultimo nodo de la lista. Si es igual a null, esta vacia. */
	ListNodePos<TObj>	*last;
};
//----------------------------------------------------------------------------
#endif
// Fin------------------------------------------------------------------------

