/** @(#) listpos/fixedlistpos.h */
/**
* Implementa una lista circular con arreglos de "Object" estatica.
* @author Omar Posada Villarreal
* @version 1.2, 10/12/2001 C++
* @version 1.1, 15/10/2001 getFirst(), getNext()
* @version 1.0, 03/10/2001
*/
#ifndef FIXEDLISTPOS_H
#define FIXEDLISTPOS_H
//----------------------------------------------------------------------------
#include "listexceptionpos.h"
#include "listpos.h"	// padre

/**
* Implementa una lista circular con arreglos de "Object" estatica.
* @author Omar Posada Villarreal
* @version 1.2, 10/12/2001 C++
* @version 1.1, 15/10/2001 getFirst(), getNext()
* @version 1.0, 03/10/2001
*/
template <class TObj>
class FixedListPos : public ListPos<TObj> {	// public muestra miembros
//error	friend ostream& operator<<(
//         	ostream &outStr, const FixedListPos<TObj> &list); // ???const <TObj>
public:
        // Constructor sin elementos, capacidad predeterminada
	FixedListPos(int capacity = INT_MAX_VALUE);
	~FixedListPos();	// Destructor. Libera memoria.

        int size() const;
	bool isEmpty() const;
	bool isFull() const;
	void print() const;

        void addFirst(const TObj item) throw (FullListExceptionPos);
	void addLast(const TObj item) throw (FullListExceptionPos);
	TObj removeFirst() throw(EmptyListExceptionPos);
	TObj removeLast() throw(EmptyListExceptionPos);
	void removeAllElements();

        TObj getLast() throw(EmptyListExceptionPos);

private:
	/** Conjunto de elementos. */
	TObj	*list;

	/** Taman~o maximo del arreglo. */
	int	capacity;

	/** Apunta al primer elemento. Si first == -1, la lista esta vacia. */
	int	first;

	/** Apunta al ultimo elemento. Si first == -1, la lista esta vacia. */
	int	last;
};
//----------------------------------------------------------------------------
#endif
// Fin------------------------------------------------------------------------

