/** @(#) listpos/listpos.h */
/**
* Permite implementar metodos uniformes para listas.
* No hay "cpp" debido a que son virtuales puras.
* @author Omar Posada Villarreal
* @version 1.3, 24/12/2001 Comparacion de signed con unsigned
* @version 2.0, 10/12/2001 C++
* @version 1.0, 03/10/2001
*/

#ifndef LISTPOS_H
#define LISTPOS_H
//----------------------------------------------------------------------------
#include "listexceptionpos.h"
//#include <stdexcept>	// runtime_exception
#include <iostream>
#include <string>
using namespace std;

/** Separador para "print()". */
const char SEPARATOR = ' ';

/** Maximo numero de elementos. */
const int INT_MAX_VALUE = 32000;

/**
* Permite implementar metodos uniformes para listas.
* No hay "cpp" debido a que son virtuales puras.
* @author Omar Posada Villarreal
* @version 2.0, 10/12/2001 C++
* @version 1.0, 03/10/2001
*/
template <class TObj>
class ListPos {
public:
	// Constructor predeterminado
	// Destructor predeterminado
        /** Taman~o de la lista. */
        virtual int size() const = 0;	// = 0 virtual pura

        /** Checa si no hay elementos en la lista. */
	virtual bool isEmpty() const = 0;  //bool 0:false, 0!=:true C++

        /** Checa si se pueden agregar mas elementos. */
	virtual bool isFull() const = 0;

        /** Muesta la lista en consola. */
	virtual void print() const = 0;


        /** Agrega un elemento al inicio de la lista. */
        virtual void addFirst(const TObj item) throw (FullListExceptionPos) = 0;

        /** Agrega un elemento al final de la lista. */
	virtual void addLast(const TObj item) throw (FullListExceptionPos) = 0;

        /** Elimina el elemento al inicio de la lista. */
	virtual TObj removeFirst() throw(EmptyListExceptionPos) = 0;

        /** Elimina el elemento al final de la lista. */
	virtual TObj removeLast() throw(EmptyListExceptionPos) = 0;

        /** Elimina todos los elementos de la lista. */
	virtual void removeAllElements() = 0;

        /** Obtiene el ultimo elemento sin quitarlo de la lista. */
        virtual TObj getLast() throw(EmptyListExceptionPos) = 0;

protected:
	/** Numero de elementos en la lista. */
	unsigned int	itemCount;
private:
};
//----------------------------------------------------------------------------
/* Extras solo dynamic
	TObj getFirst() throw(runtime_error);
	ListNodePos<TObj> * getFirstNode() throw(runtime_error);
	ListNodePos<TObj> * getNextNode(ListNodePos<TObj> * node)
        	throw(runtime_error);
	TObj get(ListNodePos<TObj> * node) throw(runtime_error);

*/
#endif
// Fin------------------------------------------------------------------------

