/** @(#) listpos/setpos.h */
/**
* Implementa el TDA de conjuntos con operaciones basicas.
* El conjunto es una lista para las operaciones de referencia
* y de insercion/eliminacion de una lista.
* @author Omar Posada Villarreal
* @version 2.0, 03/01/2002 C++
* @version 1.0, 28/10/2001
*/
#ifndef SETPOS_H
#define SETPOS_H
//----------------------------------------------------------------------------
#include "dlinklistpos.h"
#include "../utilpos/interfacepos.h"
#include <iostream>
#include <string>
#include <stdexcept>	// runtime_exception
using namespace std;

/**
* Implementa el TDA de conjuntos con operaciones basicas.
* El conjunto es una lista para las operaciones de referencia
* y de insercion/eliminacion de una lista.
* @author Omar Posada Villarreal
* @version 2.0, 03/01/2002 C++
* @version 1.0, 28/10/2001
*/
template <class TObj>
class SetPos : public DLinkListPos<TObj> {
	/* No se puede sobreescribir un operador friend
        *[Linker Error] Unresolved external
        *'operator <<(std::basic_ostream<char, std::char_traits<char> >&,
        * const SetPos<std::basic_string<char, std::char_traits<char>,
        * std::allocator<char> > >&)' referenced from
        * C:\OPOSADA\CPPSOURCE\PROGAVAN\PROG18\PROG18.OBJ.
        */
	//friend ostream & operator<<(ostream &outStr,
        //	const SetPos<TObj> &theSet);
public:
	SetPos(TObj theSet[], int count) throw (FullListExceptionPos);
	SetPos(const SetPos<TObj> &theSet);
	SetPos();
	// Destructor predeterminado de la lista

	int input();
        void print();
	int removeDuplicates();
	int setSet(TObj theSet[], int count) throw (FullListExceptionPos);

        SetPos<TObj> * unite(const SetPos<TObj> &setB);
	SetPos<TObj> * intersection(const SetPos<TObj> &setB)
		throw (FullListExceptionPos);
	SetPos<TObj> * difference(const SetPos<TObj> &setB)
		throw (FullListExceptionPos);
private:
};
//----------------------------------------------------------------------------
#endif
// Fin------------------------------------------------------------------------
