/** @(#) listpos/stackpos.h */
/**
* Implementa los metodos comunes a las pilas. 
* Representacion "FIFO", primero en entrar, primero en salir 
* ("First in, first out").
* Usa las implementaciones de "ListPos".
* @author Omar Posada Villarreal
* @version 2.0, 10/12/2001 C++
* @version 1.0, 03/10/2001
*/

#ifndef STACKPOS_H
#define STACKPOS_H
//----------------------------------------------------------------------------
#include "listpos.h"
#include "listexceptionpos.h"
#include <iostream>
#include <string>
using namespace std;

/**
* Implementa los metodos comunes a las pilas. 
* Representacion "FIFO", primero en entrar, primero en salir 
* ("First in, first out").
* Usa las implementaciones de "ListPos".
* @author Omar Posada Villarreal
* @version 2.0, 10/12/2001 C++
* @version 1.0, 03/10/2001
*/
template <class TObj>
class StackPos {
public:
	StackPos(ListPos<TObj> *pTheList); // Inicializa el tipo de lista
	// Destructor predeterminado. La lista libera memoria
        int size() const;
	bool isEmpty() const;
	bool isFull() const;
	void print() const;

	void removeAllElements();

        void push(const TObj item) throw (FullListExceptionPos);
	TObj pop() throw(EmptyListExceptionPos);
	TObj peek() throw(EmptyListExceptionPos);
private:
	ListPos<TObj> *pList;
};
//----------------------------------------------------------------------------
#endif
// Fin------------------------------------------------------------------------
